﻿using System;

namespace KludgeBox.Interfaces;

public interface ILogger
{
    void Print(object msg);
    void Succ(object msg);
    void Debug(object msg);
    void Msg(object msg);
    void Info(object msg);
    void Warn(object msg);
    void Error(object msg);
    void Fatal(object msg);
}

public class DefaultLogger : ILogger
{
    public void Print(object msg)
    {
        Console.WriteLine(msg);
    }
    public void Debug(object msg)
    {
        Console.ForegroundColor = ConsoleColor.DarkGray;
        Console.WriteLine($"[Debug] | {msg}");
    }

    public void Error(object msg)
    {
        Console.ForegroundColor = ConsoleColor.Red;
        Console.WriteLine($"[Error] | {msg}");
    }

    public void Fatal(object msg)
    {

        Console.ForegroundColor = ConsoleColor.DarkRed;
        Console.WriteLine($"[Fatal] | {msg}");
    }

    public void Info(object msg)
    {
        Console.ForegroundColor = ConsoleColor.Cyan;
        Console.WriteLine($"[Info]  | {msg}");
    }

    public void Msg(object msg)
    {
        Console.ResetColor();
        Console.WriteLine($"[Log]   | {msg}");
    }

    public void Succ(object msg)
    {
        Console.ForegroundColor = ConsoleColor.Green;
        Console.WriteLine($"[Succ]  | {msg}");
    }

    public void Warn(object msg)
    {
        Console.ForegroundColor = ConsoleColor.Yellow;
        Console.WriteLine($"[Warn]  | {msg}");
    }
}
