﻿using KludgeBox.Interfaces;

namespace KludgeBox
{
    public static class Log
    {
        public static ILogger Logger
        {
            get => _logger;
            set
            {
                _logger = value;
                _initialized = true;
            }
        }
        private static bool _initialized { get; set; } = false;

        private static ILogger _logger = new DefaultLogger();


        public static void Print(object obj) => Logger?.Print(obj);
        public static void Debug(object obj) => Logger?.Debug(obj);
        public static void Msg(object obj) => Logger?.Msg(obj);
        public static void Info(object obj) => Logger?.Info(obj);
        public static void Succ(object obj) => Logger?.Succ(obj);
        public static void Warn(object obj) => Logger?.Warn(obj);
        public static void Error(object obj) => Logger?.Error(obj);
        public static void Fatal(object obj) => Logger?.Fatal(obj);

        public static void Empty() => Print("");
        public static void Lines(int amount)
        {
            for (int i = 0; i < amount; i++)
            {
                Empty();
            }
        }
    }

    
}
