# KludgeBox.Events

Provides simple static EventBus functionality

## EventBus
Main class of this lib is EventBus.
There is two main methods:
- `Subscribe<T>(Action<T> action) where T : IEvent` - adds listener for `T` event type
- `Publish<T>(T @event) where T : IEvent` - triggers all listeners of type `T`
You also probably want to set `IncludeBaseEvents` to false, for performance reasons

## EventScanner
This thing can automatically scan all loaded assemblies and find methods, that can be used as listeners
These methods must meet the following criteria:
- return **void**
- take one **IEvent** as parameter
- be marked by **EventListenerAttribute**

Run scanner after all assemblies have been loaded.
