﻿using KludgeBox.SaveLoad;
using KludgeBox.Structs;

namespace KludgeBox_Tests.SaveLoad.Types;

public class BasicReferencable : IReferencable
{
    private static int _counter = 0;
    private readonly int _id;
    
    public int Number = 100;
    public string Text = "Text";
    public Vector2F TestVector = Vector2F.Up;

    public BasicReferencable()
    {
        _id = _counter++;
    }

    public void ExposeData()
    {
        SaveLoad_Value.Link(ref Number, "number");
        SaveLoad_Value.Link(ref Text, "text");
    }

    public string GetReferenceId()
    {
        return $"BasicReferencable#{_id}";
    }
}