﻿using KludgeBox.VFS.Archives;

namespace KludgeBox.Tests.VFS.FileSystems;

[TestFixture]
public class ZipFileSystemTests
{
    private const string ZipPath = "../../../TestData/Test.zip";

    private const string Dir1Path = "/Dir1/";
    private const string Dir2Path = "/Dir2/";
    private const string Dir3Path = "/Dir1/Dir3/";
    private const string Dir4Path = "/Dir2/Dir4/";
    
    private const string File0Path = "/File0.txt";
    private const string File1Path = Dir1Path + "File1.txt";
    private const string File2Path = Dir2Path + "File2.txt";
    private const string File3Path = Dir3Path + "File3.txt";
    private const string File4Path = Dir4Path + "File4.txt";

    [Test]
    public void TestZipFileSystem()
    {
        var fs = new ZipFileSystem(ZipPath, FileAccess.Read);
        
        Assert.That(fs.IsDirectory(Dir1Path));
        Assert.That(fs.IsDirectory(Dir2Path));
        Assert.That(fs.IsDirectory(Dir3Path));
        Assert.That(fs.IsDirectory(Dir4Path));
        
        Assert.That(fs.IsFile(File0Path));
        Assert.That(fs.IsFile(File1Path));
        Assert.That(fs.IsFile(File2Path));
        Assert.That(fs.IsFile(File3Path));
        Assert.That(fs.IsFile(File4Path));
        
        Assert.That(fs.ReadAllText(File0Path), Is.EqualTo("File0 Content"));
    }
}